{% extends "base-backend.html" %}
{% block content %}

<!-- list_media_page -->

{% set media_usage = current_user.media_usage() %}
{% set attachments_usage = current_user.attachments_usage() %}
{% set total_usage = media_usage + attachments_usage %}
{% set max_size = human_readable_bytes(config['MAX_MEDIA_SIZE']) %}

<div class="grid align-items-center ds-header-title">
  <div class="g-col-12 g-col-md-6">
    <h1>{{ _("Media") }}</h1>
  </div>
</div>

<div class="grid mt-3">
  <div class="g-col-12">
    <p class="mb-0">{{ _("Manage images to use with your forms.") }}</p>
  </div>
</div>

<div class="grid mt-3">
  <div class="g-col-12 g-col-lg-5 g-col-xxl-4">
    <div class="card">
      <div class="card-header">
        <h4>
          {{ _("Disk usage") }}:
          <span id="disk-usage-percent">
          {% if total_usage > 0 %}
          {{'%0.2f' % (( total_usage * 100) / current_user.uploads_limit )|float}} %
          {% else %}
          0 %
          {% endif %}
          </span>
        </h4>
      </div>
      <div class="card-body">
        <ul class="ds-list-group">
          <li class="fw-bold">
            <span>{{ _("Media files") }}</span>
            <span id="media_usage">{{human_readable_bytes(media_usage)}}</span>
          </li>
          <li>
            <span>{{ _("Form attachments") }}</span>
            <span>{{human_readable_bytes(attachments_usage)}}</span>
          </li>
          <li>
            <span>{{ _("Total used") }}</span>
            <span id="usage_total">{{human_readable_bytes(total_usage)}}</span>
          </li>
          <li>
            <span>{{ _("Storage limit") }}</span>
            <span>{{human_readable_bytes(current_user.uploads_limit)}}</span>
          </li>
        </ul>
      </div>
    </div>
    <div class="card mt-4">
      <div class="card-header">
        <h2>{{ _("Upload a file") }}</h2>
      </div>
      <div class="card-body">
        <form id="upload_form" name="uploadForm"
              action="{{url_for('media_bp.save_media')}}"
              method ="post"
              enctype="multipart/form-data">
          {{ wtform.csrf_token }}
          <div class="form-group">
            {{ wtform.alt_text.label( for="alt_text",
                                      class_="form-label" )
            }}
            {{ wtform.alt_text( class_="form-control form-control-sm",
                                id="alt_text",
                                placeholder=_('A photo of a horse galloping on the beach.'),
                                autocomplete="off")
            }}
            <div class="form-text">{{ _("Describe the image. This helps people with visual challenges.") }}</div>
            {% for error in wtform.alt_text.errors %}
              <span class="wtf-error ds-error-message">{{ error }}</span>
            {% endfor %}
          </div>
          <div class="form-group mt-3">
            {{ wtform.media_file.label( for="media_file",
                                        class_="form-label" )
            }}
            {{ wtform.media_file( class_="form-control form-control-sm",
                                  id="file_upload_input",
                                  multiple="false",
                                  data_parsley_max_file_size=config['MAX_MEDIA_SIZE'],
                                  data_parsley_filemimetypes="image/png, image/jpeg",
                                  required=True )
            }}
            <div class="form-text">
              {{ _("The file should be no larger than %(size)s",
                   size = human_readable_bytes(config["MAX_MEDIA_SIZE"])) }}
            </div>
            {% for error in wtform.media_file.errors %}
              <span class="wtf-error ds-error-message">{{ error }}</span>
            {% endfor %}
          </div>
          {%if current_user.is_storage_limit_exceeded()%}
          <p class="mt-4 mb-0">
            {{ _("You have exceeded your %(storage_limit)s storage limit.",
                 storage_limit=current_user.get_uploads_limit(human_readable=True)) }}
          </p>
          {% endif %}
          <div class="mt-4">
            <button class="btn btn-primary" type="submit" {%if not current_user.can_upload()%}disabled{%endif%}>{{ _("Upload") }}</button>
          </div>
        </form>
      </div>
    </div>
  </div>
  <div class="g-col-12 g-col-lg-7 g-col-xxl-8">
    <div class="card">
      <div class="card-header">
        <h2>{{ _("Media files") }}</h2>
      </div>
      <div class="card-body">
        <table id="media_list" class="table table-sm align-middle">
          <thead class="">
            <tr>
              <th>{{ _("Image") }}</th>
              <th>{{ _("Date uploaded") }}</th>
              <th>{{ _("Size") }}</th>
              <th>{{ _("File name") }}</th>
              <th></th>
            </tr>
          </thead>
          <tbody>
            {% for image in current_user.media %}
            <tr id="media_{{image.id}}">
              <td>
                <a href="{{ image.get_url()}}" alt="{{ image.alt_text}}">
                  <img src="{{ image.get_thumbnail_url() }}" alt="{{image.alt_text}}" title="{{image.alt_text}}" />
                </a>
              </td>
              <td>{{ image.created.strftime('%Y-%m-%d') }}</td>
              <td>{{ human_readable_bytes(image.file_size) }}</td>
              <td>{{ image.file_name }}</td>
              <td class="text-end"><input class="btn btn-sm btn-danger" type="button" value="{{ _('Remove') }}" onClick="javascript:removeMedia('{{image.id}}')" /></td>
            </tr>
            {% endfor %}
          </tbody>
        </table>
      </div>
    </div>
  </div>
</div>

<script>
const inline_help_file_name = "user_media.j2.md";
$(function () {
  const parsley_options = {
    errorsContainer: function (field) {
      return $(field.element).closest(".form-group")
    }
  }
  $('form[name=uploadForm]').parsley(parsley_options).on('field:validate', function(field) {
    $(field.element).closest('.form-group').find('.wtf-error').remove()
  })
  //$('form[name=uploadForm]').parsley().on('field:validated', function() {
  //  var ok = $('.parsley-error').length === 0;
  //  $('.bs-callout-info').toggleClass('hidden', !ok);
  //  $('.bs-callout-warning').toggleClass('hidden', ok);
  //})
  .on('form:submit', function() {
    event.preventDefault();
    var form_data = new FormData();
    var formFields = document.getElementById('upload_form').elements;
    var file = formFields['media_file'].files[0];
    form_data.append('media_file', file);
    form_data.append('alt_text', $('#alt_text').val());

    $.ajax({
        url : "{{url_for('media_bp.save_media')}}",
        type: "POST",
        data : form_data,
        processData: false,
        contentType: false,
        beforeSend: function(xhr, settings) {
          if (!/^(GET|HEAD|OPTIONS|TRACE)$/i.test(settings.type)) {
              xhr.setRequestHeader("X-CSRFToken", csrftoken)
          }
        },
        success: function(data, textStatus, jqXHR)
        {
          if (data !== false && data.media !== undefined) {
            let media = data.media
            let new_row = row_template.replace(/%media_id%/g, media.id)
                                      .replace(/%media_thumbnail_url%/g, media.thumbnail_url)
                                      .replace(/%media_alt_text%/g, media.alt_text)
                                      .replace(/%media_created%/g, media.created)
                                      .replace(/%media_file_size%/g, media.file_size)
                                      .replace(/%media_file_name%/g, media.file_name)
                                      .replace(/%media_url%/g, media.image_url)
            $(new_row).prependTo("#media_list");
            updateElements(data)
            $("#file_upload_input").val("")
            $("#alt_text").val("")
          }else if (data.errors !== undefined){
            alert("Error message: media_upload")
          }
        }
    });
    return false
  });
  window.Parsley
  .addValidator('maxFileSize', {
    validateString: function(_value, maxSize, parsleyInstance) {
      if (!window.FormData) {
        return true;
      }
      var files = parsleyInstance.$element[0].files;
      return files.length != 1  || files[0].size <= maxSize;
   },
    requirementType: 'integer',
    messages: {
      {{ g.language }}: "{{ _('The file is too large. Max. %(size)s', size = human_readable_bytes(config['MAX_MEDIA_SIZE'])) }}"
    }
  })
  .addValidator('filemimetypes', {
    validateString: function(_value, requirement, parsleyInstance) {
      if (!window.FormData) {
        return true;
      }
      var file = parsleyInstance.$element[0].files;
      if (file.length == 0) {
        return true;
      }
      var allowedMimeTypes = requirement.replace(/\s/g, "").split(',');
      return allowedMimeTypes.indexOf(file[0].type) !== -1;
    },
    requirementType: 'string',
    messages: {
      {{ g.language }}: "{{ _('File type not allowed') }}"
    }
  });
});
function removeMedia(media_id){
  // TODO: check if this media is used by forms
  $.ajax({
    url : "/media/delete/"+media_id,
    type: "POST",
    dataType: "json",
    beforeSend: function(xhr, settings) {
      if (!/^(GET|HEAD|OPTIONS|TRACE)$/i.test(settings.type)) {
        xhr.setRequestHeader("X-CSRFToken", csrftoken)
      }
    },
    success: function(data, textStatus, jqXHR)
    {
      if (data.media_id == media_id) {
        $('#media_'+media_id).hide();
        updateElements(data)
      } else {
        alert("Error message: media_remove-1 ")
      }
    }
  });
}
function updateElements(data) {
  $('#disk-usage-percent').html(data.usage_percent)
  $('#media_usage').html(data.media_human_usage)
  $('#usage_total').html(data.total_human_usage)
  if (data.show_alert == true) {
    $("button[type=submit]").prop("disabled", true)
    addDiskUsageAlert()
  } else {
    $("button[type=submit]").prop("disabled", false)
    removeDiskUsageAlert()
  }
};
const row_template = `
<tr id="media_%media_id%">
  <td>
    <a href="%media_url%" alt="%media_alt_text%">
      <img src="%media_thumbnail_url%" alt="%media_alt_text%" title="%media_alt_text%" />
    </a>
  </td>
  <td>%media_created%</td>
  <td>%media_file_size%</td>
  <td>%media_file_name%</td>
  <td class="text-end"><input class="btn btn-sm btn-danger" type="button" value="{{ _('Remove') }}" onClick="javascript:removeMedia('%media_id%')" /></td>
</tr>
`
</script>

{% endblock %}
